unit Test;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, SylkReports, COMReports, DDEReports, ReportContainer, CommonType,
  DDEClient, ShellApi, WordReports, XLS4Reports;

type
  TForm1 = class(TForm)
    ReportContainer1: TReportContainer;
    ExcelDDEReport1: TExcelDDEReport;
    ExcelCOMReport1: TExcelCOMReport;
    SylkReport1: TSylkReport;
    RadioGroup1: TRadioGroup;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    DdeMgrClient1: TDdeMgrClient;
    Label1: TLabel;
    ReportContainer2: TReportContainer;
    ExcelDDEReport2: TExcelDDEReport;
    ExcelCOMReport2: TExcelCOMReport;
    SylkReport2: TSylkReport;
    RTF: TWordReport;
    HTML: TWordReport;
    XLS4Report1: TXLS4Report;
    XLS4Report2: TXLS4Report;
    procedure ReportContainer1MoveTop(Sender: TObject;
      var bCheck: Boolean);
    procedure ReportContainer1MoveNext(Sender: TObject;
      var bCheck: Boolean);
    procedure ReportContainer1ReportError(Sender: TObject; mError,
      nError: Cardinal; sError: String);
    procedure ReportContainer1SectionCheck(Sender: TObject;
      SectionName: String; SectionNum: Cardinal; var bCheck: Boolean);
    procedure ReportContainer1RequestByName(Sender: TObject;
      sSectionName: String; var sFieldName, sStr: String);
    procedure ReportContainer1RequestByNum(Sender: TObject;
      sSectionName: String; var iP: Integer; var sStr: String);
    procedure ReportContainer1DataRequest(Sender: TObject;
      SectionName: String; SectionNum: Cardinal; var sData: Variant;
      var bCheck: Boolean; OutR, OutC, InR, InC: Cardinal);
    procedure Button1Click(Sender: TObject);
    procedure ReportContainer1EndReport(Sender: TObject);
    procedure ExcelDDEReport1EndReport(Sender: TObject);
    procedure SylkReport1EndReport(Sender: TObject);
    procedure ExcelCOMReport1EndReport(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ReportContainer2MoveTop(Sender: TObject;
      var bCheck: Boolean);
    procedure ReportContainer2MoveNext(Sender: TObject;
      var bCheck: Boolean);
    procedure ReportContainer2ReportError(Sender: TObject; mError,
      nError: Cardinal; sError: String);
    procedure ReportContainer2SectionCheck(Sender: TObject;
      SectionName: String; SectionNum: Cardinal; var bCheck: Boolean);
    procedure ReportContainer2DataRequest(Sender: TObject;
      SectionName: String; SectionNum: Cardinal; var sData: Variant;
      var bCheck: Boolean; OutR, OutC, InR, InC: Cardinal);
    procedure Button5Click(Sender: TObject);
    procedure ExcelDDEReport2EndReport(Sender: TObject);
    procedure ExcelCOMReport2EndReport(Sender: TObject);
    procedure SylkReport2EndReport(Sender: TObject);
    procedure ReportContainer2EndReport(Sender: TObject);
    procedure RTFEndReport(Sender: TObject);
    procedure HTMLEndReport(Sender: TObject);
    procedure ReportContainer1SectionComplit(Sender: TObject;
      SectionName: String; SectionNum: Cardinal);
    procedure SylkReport1SectionComplit(Sender: TObject;
      SectionName: String; SectionNum: Cardinal);
    procedure XLS4Report1EndReport(Sender: TObject);
    procedure XLS4Report2EndReport(Sender: TObject);
  private
    { Private declarations }
    ii, jj: Integer;
    COM: Boolean;
    SYLK: Boolean;
    eee: Integer;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.ReportContainer1MoveTop(Sender: TObject;
  var bCheck: Boolean);
begin
  ii := 1;
  bCheck := false;
end;

procedure TForm1.ReportContainer1MoveNext(Sender: TObject;
  var bCheck: Boolean);
begin
  bCheck := false;
  if ReportContainer1.TypeDiraction = tdVerticaly then
    if (ii = 100) then bCheck := true;
  if ReportContainer1.TypeDiraction = tdHorizontaly then
    if (ii = 49) then bCheck := true;
  Label1.Caption := IntToStr(ii);
  Application.ProcessMessages;
  Inc(ii);
end;

procedure TForm1.ReportContainer1ReportError(Sender: TObject; mError,
  nError: Cardinal; sError: String);
begin
  ShowMessage(sError);
end;

procedure TForm1.ReportContainer1SectionCheck(Sender: TObject;
  SectionName: String; SectionNum: Cardinal; var bCheck: Boolean);
begin
  bCheck := true;
end;

procedure TForm1.ReportContainer1RequestByName(Sender: TObject;
  sSectionName: String; var sFieldName, sStr: String);
begin
  sStr := '  - ' + sFieldName;
end;

procedure TForm1.ReportContainer1RequestByNum(Sender: TObject;
  sSectionName: String; var iP: Integer; var sStr: String);
begin
  sStr := '  - ' + IntToStr(iP);
end;

procedure TForm1.ReportContainer1DataRequest(Sender: TObject;
  SectionName: String; SectionNum: Cardinal; var sData: Variant;
  var bCheck: Boolean; OutR, OutC, InR, InC: Cardinal);
begin
  if VarType(sData) in [varSmallint, varInteger, varSingle, varDouble, varCurrency] then begin
    sData := ' - ' + VarToStr(sData);
    bCheck := true;
  end else
    bCheck := false;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  COM := false;
  case RadioGroup1.ItemIndex of
  0:  //DDE XLS
    begin
      ExcelDDEReport1.InputBlank := 'qq.xls';
      ExcelDDEReport1.InputSheet := 'qq';
      ExcelDDEReport1.OutputBlank := 'qqOut.xls';
      ReportContainer1.Report := ExcelDDEReport1;
    end;
  1:  //COM XLS
    begin
      ExcelCOMReport1.InputBlank := 'qq.xls';
      ExcelCOMReport1.InputSheet := 'qq';
      ExcelCOMReport1.OutputBlank := 'qqOut.xls';
      COM := true;
      ReportContainer1.Report := ExcelCOMReport1;
    end;
  2:  //XLS 4
    begin
      XLS4Report1.InputBlank := 'qq4.xls';
      XLS4Report1.OutputBlank := 'qq4Out.xls';
      ReportContainer1.Report := XLS4Report1;
    end;
  3:  //SYLK
    begin
      SylkReport1.InputBlank := 'qq.slk';
      SylkReport1.OutputBlank := 'qqOut.slk';
      ReportContainer1.Report := SylkReport1;
    end;
  4:  //RTF
    begin
      RTF.InputBlank := 'qq.RTF';
      RTF.OutputBlank := 'qqOut.RTF';
      ReportContainer1.Report := RTF;
    end;
  5:  //HTML
    begin
      HTML.InputBlank := 'qq.HTML';
      HTML.OutputBlank := 'qqOut.HTML';
      ReportContainer1.Report := HTML;
    end;
  end;
  ReportContainer1.ReportExecute;
end;

procedure TForm1.ReportContainer1EndReport(Sender: TObject);
begin
  if Assigned(ReportContainer1.OnOldEndReport) then ReportContainer1.OnOldEndReport(self);
end;

procedure TForm1.ExcelDDEReport1EndReport(Sender: TObject);
begin
  ExcelDDEReport1.Excel.OpenWorkBook(ExcelDDEReport1.OutputBlank);
  ExcelDDEReport1.Excel.AppActivate;
  ExcelDDEReport1.Excel.AppMaximize;
end;

procedure TForm1.SylkReport1EndReport(Sender: TObject);
begin
  ShellExecute(self.Handle, Pchar('open'), pChar(SylkReport1.OutputBlank), Pchar('/n'), nil, SW_SHOWNORMAL);
end;

procedure TForm1.ExcelCOMReport1EndReport(Sender: TObject);
begin
  ExcelCOMReport1.Excel.Visible[0] := true;
  ExcelCOMReport1.Excel.Workbooks.Open(ExcelCOMReport1.OutputBlank, true, true, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  case RadioGroup1.ItemIndex of
  0:
    begin
      ExcelDDEReport1.InputBlank := 'qqH.xls';
      ExcelDDEReport1.InputSheet := 'qqH';
      ExcelDDEReport1.OutputBlank := 'qqHOut.xls';
      ReportContainer1.Report := ExcelDDEReport1;
      ReportContainer1.ReportHorizontalyExecute;
    end;
  1:
    begin
      ExcelCOMReport1.InputBlank := 'qqH.xls';
      ExcelCOMReport1.InputSheet := 'qqH';
      ExcelCOMReport1.OutputBlank := 'qqHOut.xls';
      ReportContainer1.Report := ExcelCOMReport1;
      ReportContainer1.ReportHorizontalyExecute;
    end;
  2:
    begin
      XLS4Report1.InputBlank := 'qqH4.xls';
      XLS4Report1.OutputBlank := 'qqH4Out.xls';
      ReportContainer1.Report := XLS4Report1;
      ReportContainer1.ReportHorizontalyExecute;
    end;
  3:
    begin
      SylkReport1.InputBlank := 'qqH.slk';
      SylkReport1.OutputBlank := 'qqHOut.slk';
      ReportContainer1.Report := SylkReport1;
      ReportContainer1.ReportHorizontalyExecute;
    end;
  4:  ShowMessage('Capability not suported!');
  5:  ShowMessage('Capability not suported!');
  end;
end;

procedure TForm1.ReportContainer2MoveTop(Sender: TObject;
  var bCheck: Boolean);
begin
  ii := 1;
  jj := 1;
  bCheck := false;
end;

procedure TForm1.ReportContainer2MoveNext(Sender: TObject;
  var bCheck: Boolean);
begin
  bCheck := false;
  if ReportContainer2.TypeDiraction = tdVerticaly then
  begin
    if (jj = 100) then bCheck := true;
    Label1.Caption := IntToStr(jj);
    Application.ProcessMessages;
    Inc(jj);
  end;
  if ReportContainer2.TypeDiraction = tdHorizontaly then
  begin
    if (ii = 10) then bCheck := true;
    Label1.Caption := IntToStr(ii);
    Application.ProcessMessages;
    Inc(ii);
  end;
end;

procedure TForm1.ReportContainer2ReportError(Sender: TObject; mError,
  nError: Cardinal; sError: String);
begin
  ShowMessage(sError);
end;

procedure TForm1.ReportContainer2SectionCheck(Sender: TObject;
  SectionName: String; SectionNum: Cardinal; var bCheck: Boolean);
begin
  bCheck := true;
end;

procedure TForm1.ReportContainer2DataRequest(Sender: TObject;
  SectionName: String; SectionNum: Cardinal; var sData: Variant;
  var bCheck: Boolean; OutR, OutC, InR, InC: Cardinal);
begin
  if not (VarIsEmpty(sData) or VarIsNull(sData)) then begin
    if ReportContainer2.TypeDiraction = tdHorizontaly then
      sData := 10*ii + StrToInt(sData);
    if ReportContainer2.TypeDiraction = tdVerticaly then
    begin
        sData := Format('%d, %d, %d, %d', [ OutR,
                                            OutC,
                                            InR,
                                            InC]);
    end;
    bCheck := true;
  end;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  SYLK := false;
  case RadioGroup1.ItemIndex of
  0:
    begin
      ExcelDDEReport2.InputBlank := 'BiDirection.xls';
      ExcelDDEReport2.InputSheet := 'BiDirection';
      ExcelDDEReport2.OutputBlank := 'BiDirectionOut.xls';
      ReportContainer2.Report := ExcelDDEReport2;
      ReportContainer2.BiDirectionExecute;
    end;
  1:
    begin
      ExcelCOMReport2.InputBlank := 'BiDirection.xls';
      ExcelCOMReport2.InputSheet := 'BiDirection';
      ExcelCOMReport2.OutputBlank := 'BiDirectionOut.xls';
      ReportContainer2.Report := ExcelCOMReport2;
      ReportContainer2.BiDirectionExecute;
    end;
  2:
    begin
      XLS4Report2.InputBlank := 'BiDirection4.xls';
      XLS4Report2.OutputBlank := 'BiDirection4Out.xls';
      ReportContainer2.Report := XLS4Report2;
      ReportContainer2.BiDirectionExecute;
    end;
  3:
    begin
      SylkReport2.InputBlank := 'BiDirection.slk';
      SylkReport2.OutputBlank := 'BiDirectionOut.slk';
      ReportContainer2.Report := SylkReport2;
      SYLK := true;
      ReportContainer2.BiDirectionExecute;
    end;
  4: ShowMessage('Capability not suported!');
  5: ShowMessage('Capability not suported!');
  end;
end;

procedure TForm1.ExcelDDEReport2EndReport(Sender: TObject);
begin
  if ReportContainer2.TypeDiraction = tdVerticaly then
  begin
    ExcelDDEReport2.Excel.OpenWorkBook(ExcelDDEReport2.OutputBlank);
    ExcelDDEReport2.Excel.AppActivate;
    ExcelDDEReport2.Excel.AppMaximize;
  end;
end;

procedure TForm1.ExcelCOMReport2EndReport(Sender: TObject);
begin
  if ReportContainer2.TypeDiraction = tdVerticaly then
  begin
    ExcelCOMReport2.Excel.Visible[0] := true;
    ExcelCOMReport2.Excel.Workbooks.Open(ExcelCOMReport2.OutputBlank, true, true, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0);
  end;
end;

procedure TForm1.SylkReport2EndReport(Sender: TObject);
begin
  if ReportContainer2.TypeDiraction = tdVerticaly then
    ShellExecute(self.Handle, Pchar('open'), pChar(SylkReport2.OutputBlank), Pchar('/n'), nil, SW_SHOWNORMAL);
end;

procedure TForm1.ReportContainer2EndReport(Sender: TObject);
begin
  if Assigned(ReportContainer2.OnOldEndReport) then ReportContainer2.OnOldEndReport(self);
end;

procedure TForm1.RTFEndReport(Sender: TObject);
begin
  ShellExecute(self.Handle, Pchar('open'), pChar(RTF.OutputBlank), Pchar('/n'), nil, SW_SHOWNORMAL);
end;

procedure TForm1.HTMLEndReport(Sender: TObject);
begin
  ShellExecute(self.Handle, Pchar('open'), pChar(HTML.OutputBlank), Pchar('/n'), nil, SW_SHOWNORMAL);
end;

procedure TForm1.ReportContainer1SectionComplit(Sender: TObject;
  SectionName: String; SectionNum: Cardinal);
begin
  if Assigned(ReportContainer1.OnOldSectionComplit) then
    ReportContainer1.OnOldSectionComplit(self, SectionName, SectionNum)
  else if SectionName = 'BODY' then
  begin
    Inc(eee);
    Caption := IntToStr(eee);
  end;
end;

procedure TForm1.SylkReport1SectionComplit(Sender: TObject;
  SectionName: String; SectionNum: Cardinal);
begin
  if SectionName = 'BODY' then
  begin
    Inc(eee);
    Caption := 'BODY  SylkReport1: ' + IntToStr(eee);
  end;
end;

procedure TForm1.XLS4Report1EndReport(Sender: TObject);
begin
  ShellExecute(self.Handle, Pchar('open'), pChar(XLS4Report1.OutputBlank), Pchar('/n'), nil, SW_SHOWNORMAL);
end;

procedure TForm1.XLS4Report2EndReport(Sender: TObject);
begin
  if ReportContainer2.TypeDiraction = tdVerticaly then
    ShellExecute(self.Handle, Pchar('open'), pChar(XLS4Report2.OutputBlank), Pchar('/n'), nil, SW_SHOWNORMAL);
end;

end.
